package org.mekelburger.moritz.scanble;

import android.bluetooth.BluetoothDevice;

/**
 * Created by moritz on 08.11.2014.
 */
public class Beacon extends SimpleBeacon{
    private String mac = new String();
    private AdvertisementHistory advertisements = new AdvertisementHistory();
    private long last_advertisement_ts = 0;

    private int tx;

    private final static float C = -(float) Math.log(10) / 20;

    public Beacon(BluetoothDevice device, byte[] scanRecord, float[] position) {
        super(position, 0, 0);
        this.mac = device.getAddress();
        this.tx = scanRecord[29];
    }

    public SimpleBeacon flatCopy() {
        SimpleBeacon result = new SimpleBeacon(this.getPosition().clone(), this.getDistance(),
                this.getDistanceError());
        return result;
    }

    public void add_rssi(int rssi) {
        this.last_advertisement_ts = System.currentTimeMillis();
        this.advertisements.addAdvertisement(rssi);
    }

    public float getDistance() {
        float ratio_power = this.tx - this.advertisements.getAverageValue();
        return (float) Math.pow(Math.pow(10., ratio_power / 10.), 0.5);
    }

    public float getDistanceError() {
        return Beacon.C * this.getDistance() * this.advertisements.getError();
    }

    public String getMac() {
        return this.mac;
    }
}
